//---------------------------------------------------------------------
//		ݒ_CAO
//---------------------------------------------------------------------
#include <windows.h>
#include <commctrl.h>
#include <shellapi.h>
#include <shlwapi.h>

#include "resource.h"
#include "conf_dlg.h"

typedef LRESULT (*OLDPROC)(HWND, UINT, WPARAM, LPARAM);
static OLDPROC old_proc;

static LRESULT CALLBACK edit_proc(HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam);

static void init_dlg(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam);
static void check_dlg(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam);
static void end_dlg(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam);
static void destroy_dlg(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam);

//---------------------------------------------------------------------
// ݒ_CAO
//---------------------------------------------------------------------
LRESULT CALLBACK func_config_proc(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam)
{
	switch( umsg ) {
		case WM_INITDIALOG:
			init_dlg(hdlg, umsg, wparam, lparam);
			return TRUE;
		case WM_COMMAND:
			switch( LOWORD(wparam) ) {
				case IDCANCEL:
					end_dlg(hdlg, umsg, wparam, lparam);
					break;
				case IDOK:
					check_dlg(hdlg, umsg, wparam, lparam);
					end_dlg(hdlg, umsg, wparam, lparam);
					break;
			}
			break;
		case WM_DESTROY:
			destroy_dlg(hdlg, umsg, wparam, lparam);
			break;
	}
	return FALSE;
}

LRESULT CALLBACK edit_proc(HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam)
{
	TCHAR buf[MMS_MAX_CMDLINE + MMS_MAX_PATH];

	//D&DE
	if(umsg == WM_DROPFILES){
		if(IDC_WORKDIR == GetDlgCtrlID(hwnd)){
			DragQueryFile((HDROP)wparam, 0, buf, MMS_MAX_PATH);
			buf[MMS_MAX_PATH - 1] = TEXT('\0');
		}else{
			//eLXg𖖔ɒǉ
			int ln = GetWindowText(hwnd, buf, MMS_MAX_CMDLINE);
			DragQueryFile((HDROP)wparam, 0, &buf[ln], MMS_MAX_PATH);
			buf[MMS_MAX_CMDLINE + MMS_MAX_PATH - 1] = TEXT('\0');
		}
		DragFinish((HDROP)wparam);
		SetWindowText(hwnd, buf);
		return 0;
	}

	return CallWindowProc((WNDPROC)old_proc, hwnd, umsg, wparam, lparam);
}

void init_dlg(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam)
{	
	//MMX/SSE
	CheckDlgButton(hdlg, IDC_USE_MMX, config.use_mmx);
	CheckDlgButton(hdlg, IDC_USE_SSE2, config.use_sse2);

	//R}hs
	CheckDlgButton(hdlg, IDC_ENABLE_CMDEXE, config.command);
	SetDlgItemText(hdlg, IDC_WORKDIR, config.work_dir);
	SetDlgItemText(hdlg, IDC_CMDLINE, config.cmd_line);

	//ǂ݃obt@
	SetDlgItemInt(hdlg, IDC_BUFNUM, config.buf_num, FALSE);
	SendDlgItemMessage(hdlg, IDC_BUFNUM_SPIN, UDM_SETRANGE32, 1, 32);


	//wind procivV[WLĂƉj
	old_proc = (OLDPROC)SetWindowLongPtr(GetDlgItem(hdlg, IDC_WORKDIR),
		GWLP_WNDPROC, (LONG_PTR)edit_proc);
	SetWindowLongPtr(GetDlgItem(hdlg, IDC_CMDLINE), GWLP_WNDPROC, (LONG_PTR)edit_proc);
}

void check_dlg(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam)
{
	//MMX/SSE
	config.use_mmx = (BST_CHECKED == IsDlgButtonChecked(hdlg, IDC_USE_MMX)) ? true : false;
	config.use_sse2 = (BST_CHECKED == IsDlgButtonChecked(hdlg, IDC_USE_SSE2)) ? true : false;

	//R}hs
	config.command = (BST_CHECKED == IsDlgButtonChecked(hdlg, IDC_ENABLE_CMDEXE)) ? true : false;
	GetDlgItemText(hdlg, IDC_WORKDIR, config.work_dir, MMS_MAX_PATH);
	GetDlgItemText(hdlg, IDC_CMDLINE, config.cmd_line, MMS_MAX_CMDLINE);
	config.work_dir[MMS_MAX_PATH - 1] = TEXT('\0');
	config.cmd_line[MMS_MAX_CMDLINE - 1] = TEXT('\0');
	if(0 == lstrlen(config.cmd_line) && config.command){
		MessageBox(NULL, TEXT("R}hݒ肳Ă܂"), NULL, MB_OK|MB_ICONERROR);
		config.command = false;
	}

	//ǂ݃obt@
	BOOL t;
	UINT n = GetDlgItemInt(hdlg, IDC_BUFNUM, &t, FALSE);
	if(t && n>0 && n<=BUFF_NUM_MAX){
		config.buf_num = n;
	}else{
		n = BUFF_NUM_DEF;
	}

}

void end_dlg(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam)
{
	EndDialog(hdlg,LOWORD(wparam));
}

void destroy_dlg(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam)
{
	SetWindowLongPtr(GetDlgItem(hdlg, IDC_WORKDIR), GWLP_WNDPROC, (LONG_PTR)old_proc);
	SetWindowLongPtr(GetDlgItem(hdlg, IDC_CMDLINE), GWLP_WNDPROC, (LONG_PTR)old_proc);
}

//---------------------------------------------------------------------
// R}h̎s
//---------------------------------------------------------------------
bool cmd_exec(LPCTSTR out)
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	TCHAR *pwork = NULL;

	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(STARTUPINFO);
	ZeroMemory(&pi, sizeof(pi));

	//R}hC̃`FbN
	int l_work = lstrlen(config.work_dir);
	if(l_work > 0){
		pwork = config.work_dir;
	}
	int l_line = lstrlen(config.cmd_line);
	if(l_line == 0){
		MessageBox(NULL, TEXT("R}hCł"), NULL, MB_OK|MB_ICONERROR);
		return false;
	}

	//R}hC̕u
	// %% = %
	// %F = C:\dir\out.avu
	// %R = C:\dir\out
	// %P = C:\dir\
	// %f = out.avu
	// %r = out
	// %W = C:\workdir
	TCHAR path[MMS_MAX_PATH];	// "C:\dir\"
	TCHAR root[128];		// "out"
	TCHAR ext[8];			// ".avu"
	TCHAR iline[MMS_MAX_CMDLINE];
	TCHAR oline[2048] = TEXT("");
	int rest = ARRAYSIZE(oline) - 1; //obt@ɏc
	TCHAR *src = iline;
	int l_path, l_root, l_ext;

	lstrcpyn(iline, config.cmd_line, MMS_MAX_CMDLINE); //R}hCRs[

	//evf̏
	lstrcpyn(path, out, MMS_MAX_PATH); //o̓tpX
	path[MMS_MAX_PATH - 1] = TEXT('\0');
	lstrcpyn(ext, PathFindExtension(path), 8); //gq
	ext[8 - 1] = TEXT('\0');
	lstrcpyn(root, PathFindFileName(path), 128); //t@Cl[
	*PathFindExtension(root) = TEXT('\0'); //gq
	*PathFindFileName(path) = TEXT('\0'); //t@C
	l_path = lstrlen(path);
	l_root = lstrlen(root);
	l_ext = lstrlen(ext);

	//u
	for(int i=0; i<MMS_MAX_CMDLINE; ++i){
		if(iline[i] == TEXT('%')){
			if(iline[i+1] == TEXT('%')){
				rest--;
				iline[i+1] = TEXT('\0');
				if(rest>=0){
					lstrcat(oline, src);
				}
				src = &iline[i+2];
				++i;
			}else if(iline[i+1] == TEXT('F')){
				//o̓tpX
				rest -= (l_path + l_root + l_ext);
				iline[i] = TEXT('\0');
				if(rest>=0){ 
					lstrcat(oline, src);
					lstrcat(oline, path); 
					lstrcat(oline, root); 
					lstrcat(oline, ext);
				}
				src = &iline[i+2];
				++i;
			}else if(iline[i+1] == TEXT('R')){
				//o̓tpX-gq
				rest -= (l_path + l_root);
				iline[i] = TEXT('\0');
				if(rest>=0){  
					lstrcat(oline, src);
					lstrcat(oline, path); 
					lstrcat(oline, root); 
				}
				src = &iline[i+2];
				++i;
			}else if(iline[i+1] == TEXT('P')){
				//o̓fBNg
				rest -= l_path;
				iline[i] = TEXT('\0');
				if(rest>=0){  
					lstrcat(oline, src);
					lstrcat(oline, path);
				}
				src = &iline[i+2];
				++i;
			}else if(iline[i+1] == TEXT('W')){
				//ƃfBNg
				rest -= l_work;
				iline[i] = TEXT('\0');
				if(rest>=0){  
					lstrcat(oline, src);
					lstrcat(oline, config.work_dir);
				}
				src = &iline[i+2];
				++i;
			}else if(iline[i+1] == TEXT('f')){
				//o̓t@C
				rest -= (l_root + l_ext);
				iline[i] = TEXT('\0');
				if(rest>=0){  
					lstrcat(oline, src);
					lstrcat(oline, root);  
					lstrcat(oline, ext);
				}
				src = &iline[i+2];
				++i;
			}else if(iline[i+1] == TEXT('r')){
				//o̓t@C
				rest -= l_root;
				iline[i] = TEXT('\0');
				if(rest>=0){ 
					lstrcat(oline, src);
					lstrcat(oline, root); 
				}
				src = &iline[i+2];
				++i;
			}else{
				//̂܂
				rest--;
			}
		}else if(iline[i] == TEXT('\0')){
			if(rest>=0){
				lstrcat(oline, src);
			}
			break;
		}else{
			rest--;
		}
	}
	if(rest < 0){
		MessageBox( NULL, TEXT("R}hC܂"), NULL, MB_OK|MB_ICONERROR );
		return false;
	}

	//R}h̎s
	if(!CreateProcess(NULL, oline, NULL, NULL, FALSE,
		CREATE_NEW_CONSOLE,	NULL, pwork, &si, &pi))
	{
		LPVOID lpMsgBuf;
		if (!FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL ))
		{
			return false;
		}

		//G[̕\
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, 
			TEXT("R}hsł܂ł"), MB_OK|MB_ICONERROR );

		LocalFree( lpMsgBuf );

		return false;
	}

	return true;
}

