// ctrl_dlg.cpp
// ݒp_CAO
// Copyright (c) 2008 N099
//
#include <windows.h>
#include <process.h>
#include <intrin.h>

#include <cstdio>
#include <cstdlib>
#include <cstring>

#include "resource.h"
#include "ctrl_dlg.h"

using namespace std;

#define IDC_START               1009
#define WM_AT_READY_LOGGING    (WM_APP+201)
#define WM_AT_STARTED_LOGGING  (WM_APP+202)
#define WM_AT_INIT             (WM_APP+203)
#define WM_AT_EXIT             (WM_APP+204)

//_CAOpNX
class CtrlDlg
{
private:
	HANDLE _thr;
	HANDLE _evt;
	HWND _wnd;
	HWND _own;
	HWND _btn;
	HINSTANCE _dll;
	POINT _pos;
public:
	CtrlDlg();
	~CtrlDlg();

	//XbhZ[tł͂Ȃ
	bool IsInitialized() const { return _thr ? true : false; }

	bool Init(HINSTANCE dll, HWND wnd, POINT pos);
	bool Exit(POINT &pos);
	bool PostReadyToLogging();
	bool PostStartLogging();
private:
	void Release();
	void ProcCreate(HWND hwnd);
	void ProcStartButton();
	void ProcDestroy(HWND hwnd);
	static LRESULT CALLBACK wndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static unsigned int __stdcall thrProc(void *p);
};

static CtrlDlg cdlg;

//JAPIFXbhZ[tł͂Ȃ
BOOL ATDlgInit(HINSTANCE dll, HWND wnd, POINT &pt)
{
	if(cdlg.IsInitialized()) return TRUE;
	return cdlg.Init(dll, wnd, pt);
}

BOOL ATDlgExit(POINT &pt)
{
	if(!cdlg.IsInitialized()) return TRUE;
	return cdlg.Exit(pt);
}

BOOL ATDlgReadyToLogging()
{
	if(!cdlg.IsInitialized()) return FALSE;
	return cdlg.PostReadyToLogging();
}

BOOL ATDlgStartLogging()
{
	if(!cdlg.IsInitialized()) return FALSE;
	return cdlg.PostStartLogging();
}

//CtrlDlg
CtrlDlg::CtrlDlg() : _thr(NULL), _evt(NULL), _dll(NULL)
{
	_wnd = _btn = _own = NULL;
	_pos.x = _pos.y = 0;
}

CtrlDlg::~CtrlDlg()
{
	Release();
}

bool CtrlDlg::Init(HINSTANCE dll, HWND wnd, POINT pos)
{
	if(_thr) return true;

	_wnd = NULL;
	_btn = NULL;
	_own = wnd;
	_dll = dll;
	_pos = pos;
	if(!_evt) _evt = CreateEvent(NULL, FALSE, FALSE, NULL);
	if(!_evt) return false;

	ResetEvent(_evt);
	_thr = reinterpret_cast<HANDLE>(_beginthreadex(NULL, 0, thrProc, this, 0, NULL));
	if(!_thr){
		Release();
		return false;
	}

	//I҂
	WaitForSingleObject(_evt, INFINITE);
	
	if(_wnd == NULL){
		WaitForSingleObject(_thr, INFINITE);
		CloseHandle(_thr);
		_thr = NULL;
	}
	CloseHandle(_evt);
	_evt = NULL;

	return _thr ? true : false;
}

bool CtrlDlg::Exit(POINT &pos)
{
	if(!_thr) return true;

	Release();
	pos = _pos;
	memset(this, 0, sizeof(CtrlDlg));

	return true;
}

bool CtrlDlg::PostReadyToLogging()
{
	if(_wnd){
		PostMessage(_wnd, WM_AT_READY_LOGGING, 0, 0);
	}
	return true;
}

bool CtrlDlg::PostStartLogging()
{
	if(_wnd){
		PostMessage(_wnd, WM_AT_STARTED_LOGGING, 0, 0);
	}
	return true;
}

//CtrlDlg private
void CtrlDlg::Release()
{
	if(_thr){
		PostMessage(_wnd, WM_DESTROY, 0, 0);
		WaitForSingleObject(_thr, INFINITE);
		CloseHandle(_thr);
		_thr = NULL;
	}

	if(_evt){
		CloseHandle(_evt);
		_evt = NULL;
	}
}

void CtrlDlg::ProcCreate(HWND hwnd)
{
	SetWindowLongPtr(hwnd, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(this));
	SendMessage(hwnd, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), 1);
	SetWindowText(hwnd, "AUF Trace");
	
	_btn = CreateWindow("BUTTON", "Start", WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
		6, 6, 72, 28, hwnd, (HMENU)IDC_START, _dll, NULL);
	SendMessage(_btn, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), 1);
	SetWindowLongPtr(_btn, GWLP_USERDATA, 0);
}

void CtrlDlg::ProcStartButton()
{
	EnableWindow(_btn, FALSE);
	if(GetWindowLongPtr(_btn, GWLP_USERDATA)){
		SetWindowText(_btn, "Start");
		PostMessage(_own, WM_AT_STOP_LOGGING, 0, 0);
		SetWindowLongPtr(_btn, GWLP_USERDATA, 0);
	}else{
		SetWindowText(_btn, "Stop");
		PostMessage(_own, WM_AT_START_LOGGING, 0, 0);
		SetWindowLongPtr(_btn, GWLP_USERDATA, 1);
	}
}

void CtrlDlg::ProcDestroy(HWND hwnd)
{
	RECT rc;

	GetWindowRect(hwnd, &rc);
	_pos.x = rc.left;
	_pos.y = rc.top;
	PostQuitMessage(0);
}

LRESULT CALLBACK CtrlDlg::wndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	CtrlDlg *pdlg = reinterpret_cast<CtrlDlg*>(GetWindowLongPtr(hwnd, GWLP_USERDATA));
	CREATESTRUCT *cs;

	switch (uMsg) 
	{ 
	case WM_COMMAND:
		if(LOWORD(wParam) == IDC_START){
			pdlg->ProcStartButton();
			return 0;
		}
		break;
	case WM_AT_READY_LOGGING:
	case WM_AT_STARTED_LOGGING:
		EnableWindow(pdlg->_btn, TRUE);
		return 0;
	case WM_CREATE:
		cs = reinterpret_cast<CREATESTRUCT*>(lParam);
		pdlg = reinterpret_cast<CtrlDlg*>(cs->lpCreateParams);
		pdlg->ProcCreate(hwnd);
		return 0;
	case WM_DESTROY:
		pdlg->ProcDestroy(hwnd);
		return 0;	
	} 

	return DefWindowProc(hwnd, uMsg, wParam, lParam);
}

unsigned int CtrlDlg::thrProc(void *p)
{
	CtrlDlg *pdlg = static_cast<CtrlDlg*>(p);
	WNDCLASSEX wc = { sizeof(WNDCLASSEX), };
	const char cls_name[] = "auftrace";

	wc.lpfnWndProc   = pdlg->wndProc;
	wc.hInstance     = pdlg->_dll;
	wc.hbrBackground = reinterpret_cast<HBRUSH>(COLOR_BTNFACE + 1);
	wc.lpszClassName = cls_name;

	ATOM atm = RegisterClassEx(&wc);
	if(0 == atm){
		SetEvent(pdlg->_evt);
		_endthreadex(0);
		return 0;
	}

	pdlg->_wnd = CreateWindow(MAKEINTATOM(atm), NULL,
		WS_CAPTION | WS_POPUP | WS_VISIBLE,
		pdlg->_pos.x, pdlg->_pos.y, 92, 64,
		NULL, NULL, pdlg->_dll, p);

	SetEvent(pdlg->_evt);
	if(NULL == pdlg->_wnd){
		_endthreadex(0);
		return 0;
	}

	MSG msg;
	BOOL ret;
	while((ret = GetMessage(&msg, NULL, 0, 0)) != 0){
		if(ret == -1){
			break;
		}else{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	pdlg->_wnd = NULL;
	pdlg->_btn = NULL;
	UnregisterClass(MAKEINTATOM(atm), pdlg->_dll);

	_endthreadex(0);
	return 0;
}
