//---------------------------------------------------------------------
//		Memory Mapped T[o[ CNX
//---------------------------------------------------------------------
#include <windows.h>
#include <intrin.h>
#include <shlwapi.h>

#include <crtdbg.h>
#include <new>

#include "conf_dlg.h"
#include "mms_util.h"
#include "mms.h"
#include "msg_wnd.h"


MmSrv::MmSrv(OUTPUT_INFO *oip, MMS_CONFIG *conf) :
	_oip(oip), _conf(conf),
	_hMap(NULL), _hEvt(NULL), _hFile(NULL), _pData(NULL),
	_pMmd(NULL), _pMsgRcv(NULL), _pImgCpy(NULL), _pBuf(NULL)
{
	_fcc = _buf_num = _name_len = 0;
	_req_frame = _req_miss = 0;
	_req_waiting = false;
	_hint = RA_THR_ABS;
	_fcnt = 0;
	_mcnt = 0;
	_mcnt_prev = 0;
}

MmSrv::~MmSrv()
{
	Release();
}

bool MmSrv::InitMapping(HINSTANCE dll)
{
	/* t@C}bv̍쐬 */
	LPSTR file = PathFindFileNameA(_oip->savefile);
	if(file == _oip->savefile) return false; //t@Cُ

	/* CxgIuWFNg쐻̂߂ɕ𒲍 */
	_name_len = strlen(file);

	/* obt@Ǘ̈̊m */
	_buf_num = _conf->buf_num;
	_pBuf = new(std::nothrow) MmBuf[_buf_num * 3];
	if(NULL == _pBuf) return false;

	/* L̍쐬 */
	_hMap = CreateFileMappingA(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE,
		0, _buf_num * GetBufSizeYC48() + GetMapHeaderSize(), file);
	if(NULL == _hMap){
		return false;
	}else if(ERROR_ALREADY_EXISTS == GetLastError()){
		/* łɓ̃}bsO쐬ĂꍇG[Ƃ */
		MessageBox(NULL, TEXT("̃t@C͊ɗpĂ܂"),
			NULL, MB_OK|MB_ICONERROR);
		return false;
	}

	_pData = MapViewOfFile(_hMap, FILE_MAP_WRITE, 0, 0, 0);
	if(NULL == _pData) return false;

	/* CxgƃCxg̍쐬 */
	LPSTR ev_name = static_cast<CHAR*>(_pData) + GetSharedEvNameOffs();
	wsprintfA(ev_name, "%s%s", file, EVSUF);
	_hEvt = CreateEventA(NULL, FALSE, FALSE, ev_name);
	if(NULL == _hEvt){
		return false;
	}else if(ERROR_ALREADY_EXISTS == GetLastError()){
		/* łɓ̃Cxg쐬ĂꍇG[Ƃ */
		MessageBox(NULL, TEXT("̃t@C͊ɗpł"),
			NULL, MB_OK|MB_ICONERROR);
		return false;
	}

	/* LǗf[^ */
	_pMmd = reinterpret_cast<mm_srv_map_data*>(_pData);
	ZeroMemory(_pMmd, sizeof(mm_srv_map_data));

	/* bZ[WMEBhE쐬 */
	_pMsgRcv = new(std::nothrow) MsgRecv(dll, this);
	if(NULL == _pMsgRcv) return false;

	/* bZ[WMJn */
	if(!_pMsgRcv->StartReceiving()) return false;
	
	/* o[Wݒ */
	_pMmd->ver = MM_SRV_VER;

	/* 摜̃Zbg */
	_pMmd->w     = _oip->w;
	_pMmd->h     = _oip->h;
	_pMmd->frame = _oip->n;
	_pMmd->rate  = _oip->rate;
	_pMmd->scale = _oip->scale;
	
	/* obt@̃ZbgiڑɍXVj */
	_pMmd->nbuf   = _buf_num;
	_pMmd->idxofs = GetSharedIndexOffs();
	_pMmd->bufofs = GetSharedBufTblOffs();
	_pMmd->evtofs = GetSharedEvNameOffs();

	/* bZ[WEChEnh */
#ifdef _WIN64
	_pMmd->hMsg = _pMsgRcv->GetMsgWindow();
#else
	LONG64 *ph64 = reinterpret_cast<LONG64 *>(&_pMmd->hMsg);
	LONG_PTR hw32 = reinterpret_cast<LONG_PTR>(_pMsgRcv->GetMsgWindow());
	*ph64 = hw32;
#endif

	/* t@C̍쐬iۂɂ͗pȂj */
	_hFile = CreateFileA(_oip->savefile, GENERIC_READ,
		FILE_SHARE_READ, NULL, CREATE_ALWAYS,
		FILE_ATTRIBUTE_TEMPORARY, NULL);
	if(NULL == _hFile) return false;

	DPRINT(TEXT("MmSrv::InitMapping() Start\n"));

	/* ҂󂯉\ */
	return true;
}

bool MmSrv::WaitConnection()
{
	_ASSERT(_pMmd);

	if(_pMmd->format != 0){
		//ڑɐĂ͂
		DPRINT(TEXT("MmSrv::WaitConnection() OK\n"));
		return true;
	}else{
		WaitMessage();
		return false;
	}
}

//僋[v
bool MmSrv::DoMain()
{
	do{
		bool loop_end = false;

		//ǂ
		if(!ReadAhead(loop_end)) return false;
		if(loop_end) return true;
	}while(WaitMessage());

	return false;
}

//for msg_wnd

//:non-zero
LONG_PTR MmSrv::ReqOpen(DWORD format, DWORD align)
{
	DPRINT(TEXT("MmSrv::ReqOpen()"));
	_mcnt++;
	
	if(IsConnected()){
		DPRINT(TEXT(" NG(con)\n"));
		return 0;
	}

	//vtH[}bg`FbN
	if(!CheckFormat(format, align)){
		//vtH[}bgɑΉłȂ
		DPRINT(TEXT(" NG(fmt)\n"));
		return 0;
	}

	//align͌vZς(->pitch)
	
	//Rs[֐Ȃǂp
	if(!PrepareOutput(format, align)){
		DPRINT(TEXT(" NG(ini)\n"));
		return 0;
	}

	//ڑ
	DPRINT(TEXT(" OK(%u)\n"), format);

	return format;
}

//LbVqbgʒm
LONG_PTR MmSrv::ReqHitFrame(DWORD frame)
{
	_mcnt++;

	//ŏIt[ȍ~̓Nbv
	if(frame >= static_cast<DWORD>(_oip->n)){
		frame = (_oip->n > 0) ? (_oip->n - 1) : 0;
	}

	//݈ʒuȂǂXV
	_req_frame = frame;

	DPRINT(TEXT("MmSrv::ReqHitFrame() (%u)\n"), frame);

	return -1;
}

//:non-zero
LONG_PTR MmSrv::ReqGetFrameOffs(DWORD frame)
{	
	_ASSERT(_pMmd && _buf_num);
	_ASSERT(_pBuf && _pImgCpy);
	_mcnt++;

	if(!IsConnected()){
		return 0;
	}

	//ŏIt[ȍ~̓Nbv
	if(frame >= static_cast<DWORD>(_oip->n)){
		frame = (_oip->n > 0) ? (_oip->n - 1) : 0;
	}

	MmBuf* pmm = _pBuf + (frame % _buf_num);

	if(*(pmm->n) == static_cast<INT_PTR>(frame)){
		//HIT!
		DPRINT(TEXT("MmSrv::ReqGetFrameOffs() hit(%u)\n"), frame);
		_req_frame = frame;
		SetEvent(_hEvt);
	}else{
		//MISS
		DPRINT(TEXT("MmSrv::ReqGetFrameOffs() miss(%u)\n"), frame);
		UpdateHint(frame);
		_req_frame = _req_miss = frame;
		_req_waiting = true;
	}

	return pmm->p - static_cast<PBYTE>(_pData);
}

LONG_PTR MmSrv::ReqClose()
{
	DPRINT(TEXT("MmSrv::ReqClose()\n"));
	_mcnt++;
	_req_frame = -1;

	return 0;
}

//private

void MmSrv::Release()
{
	if(_pMmd){
		_pMmd->format = 0;
		_pMmd = NULL;
	}

	if(_hFile){
		CloseHandle(_hFile);
		_hFile = NULL;
		DeleteFileA(_oip->savefile);
	}

	if(_hEvt){
		SetEvent(_hEvt);
		CloseHandle(_hEvt);
		_hEvt = NULL;
	}

	if(_pMsgRcv){
		delete _pMsgRcv;
		_pMsgRcv = NULL;
	}

	if(_pData){
		UnmapViewOfFile(_pData);
		_pData = NULL;
	}

	SafeCloseHandle(_hMap);

	if(_pBuf){
		delete[] _pBuf;
		_pBuf = NULL;
	}
	if(_pImgCpy){
		delete _pImgCpy; 
		_pImgCpy = NULL;
	}
}

LONG_PTR MmSrv::GetMapHeaderSize() const
{
	//摜obt@܂ł̃ItZbg
	return AlignNext(GetSharedIndexOffs() + sizeof(DWORD) * _buf_num);
}

LONG_PTR MmSrv::GetBufSizeYC48() const
{
	/* MM_SRV_ALIGN_MAX byte ACőƂ */
	LONG_PTR sz_buf = _oip->w * 6; // 6:sizeof(PIXEL_YC)
	sz_buf = AlignNext(sz_buf) * _oip->h;

	return sz_buf + 64 * 6; //܂
}

LONG_PTR MmSrv::GetSharedMapStructSize() const
{
	//ACꂽ mm_srv_map_data ̃TCY
	//LLP64l
	return AlignNext(sizeof(mm_srv_map_data) + sizeof(DWORD)); 
}

LONG_PTR MmSrv::GetSharedIndexOffs() const
{
	//Lobt@ƃt[̑ΉCfbNXe[üʒu
	return AlignNext(GetSharedBufTblOffs() + sizeof(DWORD) * _buf_num);
}

LONG_PTR MmSrv::GetSharedBufTblOffs() const
{
	//Lobt@ւ̃ItZbge[üʒu
	return AlignNext(GetSharedEvNameOffs()
		+ _name_len + strlen(EVSUF) + 1);
}

LONG_PTR MmSrv::GetSharedEvNameOffs() const
{
	//LCxg(ASCII)̈ʒu
	return GetSharedMapStructSize();
}

bool MmSrv::CheckFormat(DWORD format, DWORD &align)
{
	_ASSERT(_pMmd && (_pMmd->format == 0));

	long s = align;

	if(ImgCopy::CheckFormat(format, _pMmd->h, _pMmd->w, s)){
		align = s;
		return true; //OK
	}

	return false; //NG
}

bool MmSrv::PrepareOutput(DWORD format, DWORD pitch)
{
	_ASSERT(_pMmd && _pBuf && !_pImgCpy);

	if(_pImgCpy) return false;

	//Rs[֐̎擾
	_pImgCpy = new(std::nothrow) ImgCopy(
		format, _conf->use_mmx, _conf->use_sse2,
		_pMmd->w, _pMmd->h, pitch, _pMmd->w);
	
	if(!_pImgCpy) return false;

	//obt@Ǘz̏
	PBYTE pHead = static_cast<PBYTE>(_pData);
	LONG_PTR offs = _buf_num * GetBufSizeYC48();
	int bnum = _pImgCpy->GetBufferCount(_buf_num);

	_buf_num = bnum;
	_fcc = _pImgCpy->GetSrcFCC();
	offs /= _buf_num;

	//L摜f[^z̏
	DWORD* pOffs = reinterpret_cast<DWORD*>(pHead + _pMmd->bufofs);
	volatile LONG* pIndex = reinterpret_cast<volatile LONG*>(pHead + _pMmd->idxofs);
	PBYTE pBuf = pHead + GetMapHeaderSize();

	for(int i=0; i<bnum; ++i){
		pOffs[i] = pBuf - pHead;
		pIndex[i] = -1;

		_pBuf[i].prv = (i == 0) ? _pBuf + (bnum - 1) : _pBuf + (i - 1);
		_pBuf[i].nxt = (i == bnum - 1) ? _pBuf : _pBuf + (i + 1);
		_pBuf[i].p = pBuf;
		_pBuf[i].n = pIndex + i;
		pBuf += offs;
	}

	//L^f[^Zbg
	_pMmd->format = format;
	_pMmd->pitch  = pitch;
	_pMmd->nbuf   = bnum;

	DPRINT(TEXT("MmSrv::PrepareOutput() buf:%d\n"), bnum);

	return true;
}

//ǂ݃p^[ύX邽߂̃qgXV
void MmSrv::UpdateHint(LONG frame)
{
	long diff = frame - _req_miss;
	long hint = _hint;

	//ǂݍ݈ʒu̕ωL^
	//Aւ̃NGXgJEg

	if(diff == 1){ //+1
		hint = hint >= 0 ? hint + 1 : 0;
	}else if(diff == -1){//-1
		hint = hint <= 0 ? hint - 1 : 0;
	}else if(static_cast<DWORD>(labs(diff)) > (_buf_num/2U)){
		hint = 0; //rand?
	}

	_hint = hint;
}

void MmSrv::UpdateDisp()
{
	//NGXgΒf
	if(_fcnt > DISP_UPDATE_INT){
		DPRINT(TEXT("MmSrv::UpdateDisp() update\n"));
		_fcnt -= DISP_UPDATE_INT;
		_oip->func_update_preview();
		_oip->func_rest_time_disp(_req_frame, _oip->n);
	}
}

bool MmSrv::ReadAhead(bool& loop_end)
{
	_ASSERT(_pBuf && _pImgCpy && _pMsgRcv);

	//IeXg
	if(CheckBreak()){
		loop_end = true;
		return true;
	}

	//NGXgΉ
	if(_req_waiting){
		if(!ReplyReq()) return false;
	}

	//_[h͐ǂ݂Ȃ
	if(labs(_hint) < RA_THR_ABS){
		return true;
	}

	//NCAg̗vꍇɂ͐ǂ݂Ȃ
	if(_mcnt == _mcnt_prev){
		return true;
	}
	_mcnt_prev = _mcnt;

	DPRINT(TEXT("MmSrv::ReadAhead()\n"));

	//hintɐǂ݃p^[ύX
	const bool fwd = (_hint > 0) ? true : false; //ǂݕ
	const DWORD rnum = (_buf_num * 2U + 2U) / 3U; //ǂ݃t[(2:1)
	DWORD i = 0;

	//ǂ݃[v
	//_[hɕωꍇƃobt@𖄂ߐsꍇ
	do{
		long req_frame = _req_frame;
		MmBuf* pb = _pBuf + (req_frame % _buf_num);

		DPRINT(TEXT("start"));

		for(i=0; i<rnum; ++i){
			long frame = fwd ? (req_frame + i) : (req_frame - i);

			//f[^ꍇŃt[͈͓̏ꍇɓǂݍ
			if(frame >= 0 && frame < _oip->n && *pb->n != frame){	
				PBYTE buf = static_cast<PBYTE>(_oip->func_get_video_ex(frame, _fcc));
				if(!buf) return false;

				//L̃f[^XV
				_InterlockedExchange(pb->n, -1); //f[^̖
				_pImgCpy->Copy(pb->p, buf);
				_InterlockedExchange(pb->n, frame);
				IncCnt();

				DPRINT(TEXT(" r(%ld)"), frame);
			}else{
				DPRINT(TEXT(" h(%ld)"), frame);
			}

			//̓ǂݍݑΏۂݒ
			pb = fwd ? pb->nxt : pb->prv;
			
			//\̍XV
			UpdateDisp();

			//IeXg
			if(CheckBreak()){
				loop_end = true;
				return true;
			}

			//NGXgΉ
			if(_req_waiting){
				DPRINT(TEXT(" p(%ld)"), frame);
				if(!ReplyReq()) return false;
			}

			//ǂݏoʒuωꍇ͍ŏ
			if(req_frame != _req_frame) break;
		}

		DPRINT(TEXT(" end\n"));
	}while((labs(_hint) >= RA_THR_ABS) && (i != rnum));

	return true;
}

bool MmSrv::ReplyReq()
{
	_ASSERT(_pBuf && _pImgCpy && _pMsgRcv);
	
	//肦Ȃꉞ
	if(!_req_waiting) return true;

	bool ret = true;
	long frame = _req_miss;
	MmBuf* pb = _pBuf + (frame % _buf_num);

	if(*pb->n == frame){
		//HIT!
		DPRINT(TEXT("MmSrv::ReplyReq() hit(%u)\n"), frame);
	}else{
		//Read	
		PBYTE buf = static_cast<PBYTE>(_oip->func_get_video_ex(frame, _fcc));
		if(!buf) ret = false;

		//L̃f[^XV
		_InterlockedExchange(pb->n, -1);
		_pImgCpy->Copy(pb->p, buf);
		_InterlockedExchange(pb->n, frame);
		IncCnt();

		DPRINT(TEXT("MmSrv::ReplyReq() read(%u)\n"), frame);
	}

	//ʂɂ炸NCAgN
	SetEvent(_hEvt);
	
	_req_waiting = false;
	UpdateDisp();

	return ret;
}
