//----------------------------------------------------------------------------------
//		Memory Mapped T[o[ CNX
//----------------------------------------------------------------------------------
#pragma once

//Lwb_
#define __MM_SRV_C__
#include "mm_srv.h"
#include "output.h"

//obt@Ǘp
struct MmBuf {
	MmBuf* prv;
	MmBuf* nxt;
	PBYTE p;
	volatile LONG* n;
};

struct MMS_CONFIG;
class MsgRecv;
class ImgCopy;

class MmSrv {
public:
	MmSrv(OUTPUT_INFO *oip, MMS_CONFIG *conf);
	~MmSrv();

	bool InitMapping(HINSTANCE dll);
	bool WaitConnection();
	bool DoMain();

	//for msg_wnd
	LONG_PTR ReqOpen(DWORD format, DWORD align);
	LONG_PTR ReqHitFrame(DWORD frame);
	LONG_PTR ReqGetFrameOffs(DWORD frame);
	LONG_PTR ReqClose();

private:
	OUTPUT_INFO* const _oip;
	MMS_CONFIG* const _conf;

	HANDLE _hMap;
	HANDLE _hEvt;
	HANDLE _hFile;
	VOID*  _pData;

	DWORD _fcc;
	DWORD _buf_num;
	DWORD _name_len;

	LONG _req_frame;
	LONG _req_miss;
	bool _req_waiting;

	LONG _hint;
	DWORD _fcnt;

	DWORD _mcnt;
	DWORD _mcnt_prev;

	mm_srv_map_data* _pMmd;
	MsgRecv* _pMsgRcv;
	ImgCopy* _pImgCpy;
	MmBuf* _pBuf;

	void Release();
	LONG_PTR GetMapHeaderSize() const;
	LONG_PTR GetBufSizeYC48() const;
	LONG_PTR GetSharedMapStructSize() const;
	LONG_PTR GetSharedEvNameOffs() const;
	LONG_PTR GetSharedEvNameBufSize() const
	{ return GetSharedBufTblOffs() - GetSharedEvNameOffs(); }
	LONG_PTR GetSharedIndexOffs() const;
	LONG_PTR GetSharedBufTblOffs() const;

	bool CheckFormat(DWORD format, DWORD &align);
	bool PrepareOutput(DWORD format, DWORD pitch);
	void UpdateHint(LONG frame);
	bool CheckBreak() const { return _oip->func_is_abort() || _req_frame < 0; }
	void IncCnt() { _fcnt++; }
	void UpdateDisp();
	bool ReadAhead(bool& loop_end);
	bool ReplyReq();
	bool IsConnected() const { return _pMmd && _pMmd->format; }
	ULONG_PTR AlignNext(ULONG_PTR c) const
	{ return (c + MM_SRV_ALIGN_MAX - 1U) & ~(MM_SRV_ALIGN_MAX - 1U); }
	void SafeCloseHandle(HANDLE &h) { if(h){ CloseHandle(h); h = NULL;} }
	MmSrv& operator=(const MmSrv& m);

	//hintp
	static const LONG RA_THR_ABS = 15;
	static const DWORD DISP_UPDATE_INT = 15;

	#define EVSUF ".evt"
};

#ifdef _DEBUG
#define DPRINT(s, ...) { TCHAR buf[1024];\
	wsprintf(buf, s, __VA_ARGS__); OutputDebugString(buf); }
#else
#define DPRINT(s, ...)
#endif
