//---------------------------------------------------------------------
//	̑
//---------------------------------------------------------------------
#pragma once

typedef VOID(*CPF)(BYTE*, const BYTE*, UINT, UINT, UINT, UINT, UINT);

class ImgCopy {
public:
	ImgCopy(DWORD fmt, bool mmx, bool sse2,
		UINT swIn, UINT Height, UINT swOut, UINT Width);
	~ImgCopy(){}

	void Copy(unsigned char *dst, const unsigned char *src);
	DWORD GetSrcFCC() const { return _fcc; }
	int GetBufferCount(int count_in_yc48) const
	{ return _buf_cnt_mul * count_in_yc48; }

	static long GetPitch(long align, long w, long bpp);
	static bool CheckFormat(DWORD fmt, long h, long w, long &pitch);

private:
	DWORD _fmt;
	DWORD _fcc;
	UINT _bpp;
	UINT _swIn;
	UINT _Height;
	UINT _swOut;
	UINT _Width;
	int _buf_cnt_mul;
	CPF _cpfunc;
	CPF _cpfunc_na; //non-16byte aligned

	void SetCopyFunc(bool mmx, bool sse2);
	void SetLineCopyFunc(bool bu, bool sse2);
	void SetYV12CnvFunc(bool ires, bool mmx, bool sse2);
};

