//---------------------------------------------------------------------
//		YUY2->YV12ϊ֐
//---------------------------------------------------------------------
#include <emmintrin.h>

#include "yv12cnv.h"

/*
 * YUY2 -> YV12
 * vObVuȉ摜p
 *
 * (1,7,7,1)/16  4tap tB^[
 *
 */
void yuy2_2_yv12(unsigned char *pBufferOut, const unsigned char *pBufferIn,
				 unsigned int bpp, unsigned int Height, unsigned int Width,
				 unsigned int swIn, unsigned int swOut)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	unsigned int i,j,k;
	const unsigned int coffs = (swOut * Height) / 4U; //F̃TCY
	const unsigned int hHeight = Height / 2U;
	const unsigned char *tmp_pBufferIn = pBufferIn;
	const unsigned char *i0,*i1,*i2,*i3;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn += swIn;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		for(j=0; j<Width; ++j) {
			pBufferOut[j] = tmp_pBufferIn[j*2U];
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UVTuTvȂRs[
	Width /= 2U;
	swOut /= 2U;
	for(i=0; i<hHeight; ++i) {
		i1 = pBufferIn + 1;
		i2 = i1 + swIn;
		i0 = (i==0) ? i1 : i1 - swIn;
		i3 = (i >= hHeight-1U) ? i2 : i2 + swIn;

		for(j=0; j<Width; ++j) {
			//u
			k = (i1[j*4U] + i2[j*4U]) * 7U + (i0[j*4U] + i3[j*4U]) + 8U;
			pBufferOut[j + coffs] = (unsigned char)(k >> 4);
			//v
			k = (i1[j*4U+2U] + i2[j*4U+2U]) * 7U + (i0[j*4U+2U] + i3[j*4U+2U]) + 8U;
			pBufferOut[j] = (unsigned char)(k >> 4);
		}
		pBufferOut += swOut;
		pBufferIn  += swIn + swIn; //2line -> 1line
	}

}

/*
 * YUY2 -> YV12
 * C^[[X(FTvʒuMPEG2)ȉ摜p
 *
 * (5,15,11,1)/32  4tap tB^[ivtB^{TuTvj
 *
 */
void iq_yuy2_2_yv12(unsigned char *pBufferOut, const unsigned char *pBufferIn,
					unsigned int bpp, unsigned int Height, unsigned int Width,
					unsigned int swIn, unsigned int swOut)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	unsigned int i,j,k;
	const unsigned int coffs = (swOut * Height) / 4U; //F̃TCY
	const unsigned int hHeight = Height / 2U;
	unsigned int swIn2;
	const unsigned char *tmp_pBufferIn = pBufferIn;
	const unsigned char *i0,*i1,*i2,*i3;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2U;
	swIn2 = swIn * 2U;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		for(j=0; j<Width; ++j) {
			pBufferOut[j] = tmp_pBufferIn[j*2U];
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	Width /= 2;
	swOut /= 2;
	for(i=0; i<hHeight; ++i) {
		if(i&1U){ //{g
			i1 = pBufferIn + 1 + swIn;
			i2 = i1 - swIn2;
			i3 = (i<2U) ? i2 : i2 - swIn2;
			i0 = (i >= hHeight-2U) ? i1 : i1 + swIn2;
		}else{ //gbv
			i1 = pBufferIn + 1;
			i2 = i1 + swIn2;
			i0 = (i<2U) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2U) ? i2 : i2 + swIn2;
		}

		for(j=0; j<Width; ++j) {
			//u
			k  = 15U * i1[j*4U] + 11U * i2[j*4U];
			k +=  5U * i0[j*4U] +       i3[j*4U];
			k += 16U;
			pBufferOut[j + coffs] = (unsigned char)(k >> 5);
			//v
			k  = 15U * i1[j*4U+2U] + 11U * i2[j*4U+2U];
			k +=  5U * i0[j*4U+2U] +       i3[j*4U+2U];
			k += 16U;
			pBufferOut[j] = (unsigned char)(k >> 5);
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
		
}

/*
 * YUY2 -> YV12
 * vObVuȉ摜p MMX
 *
 * (1,7,7,1)/16  4tap tB^[
 * 8̔{̂ݑΉ
 */
void mmx_yuy2_2_yv12(unsigned char *pBufferOut, const unsigned char *pBufferIn,
					 unsigned int bpp, unsigned int Height, unsigned int Width,
					 unsigned int swIn, unsigned int swOut)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	unsigned int i,j;
	const unsigned int coffs = (swOut * Height) / 4U; //F̃TCY
	const unsigned int hHeight = Height / 2U;
	const unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	const unsigned char *i0,*i1,*i2,*i3;
	__m64 m0,m1,m2,m3,mm;

	//8̔{̂ݑΉ
	if(Width & 7U)
		return;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2U;

	//ỸRs[
	mm = _mm_setzero_si64();
	mm = _mm_cmpeq_pi8(mm, mm);
	mm = _mm_srli_pi16(mm, 8);
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j = 0; j<Width; j+=8U) {
			m0 = _mm_and_si64(*(__m64 *)i0,       mm);
			m1 = _mm_and_si64(*(__m64 *)(i0 + 8), mm);
			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m0, m1);
			tmp_pBufferOut += 8;
			i0 += 16;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	swOut /= 2U;
	mm = _mm_srli_pi16(mm, 7);
	mm = _mm_slli_pi16(mm, 3);
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		i1 = pBufferIn;
		i2 = i1 + swIn;
		i0 = (i==0) ? i1 : i1 - swIn;
		i3 = (i >= hHeight-1U) ? i2 : i2 + swIn;

		for(j=0; j<Width; j+=8U) {
			//1st
			// +
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m0 = _mm_add_pi16(m0, m1);
			// *7
			m2 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m2 = _mm_add_pi16(m2, m1);
			m1 = _mm_slli_pi16(m2, 3);
			m1 = _mm_sub_pi16(m1, m2);
			// +8
			m0 = _mm_add_pi16(m0, mm);
			m0 = _mm_add_pi16(m0, m1);
			m3 = _mm_srli_pi16(m0, 4);
			// m3 (v1,u1,v0,u0)
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
			//2nd
			// +
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m0 = _mm_add_pi16(m0, m1);
			// *7
			m2 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m2 = _mm_add_pi16(m2, m1);
			m1 = _mm_slli_pi16(m2, 3);
			m1 = _mm_sub_pi16(m1, m2);
			// +8
			m0 = _mm_add_pi16(m0, mm);
			m0 = _mm_add_pi16(m0, m1);
			m0 = _mm_srli_pi16(m0, 4);
			// m0 (v3,u3,v2,u2)

			//de-interleave
			m1 = _mm_unpackhi_pi16(m3, m0); //m1 (v3,v1,u3,u1)
			m3 = _mm_unpacklo_pi16(m3, m0); //m3 (v2,v0,u2,u0)
			m0 = _mm_unpackhi_pi16(m3, m1); //m0 (v3,v2,v1,v0)
			m3 = _mm_unpacklo_pi16(m3, m1); //m3 (u3,u2,u1,u0)

			m0 = _mm_packs_pu16(m0, m0); //v
			m3 = _mm_packs_pu16(m3, m3); //u

			*(int *)tmp_pBufferOut = _mm_cvtsi64_si32(m0); //v
			*(int *)(tmp_pBufferOut + coffs) = _mm_cvtsi64_si32(m3); //u
			tmp_pBufferOut += 4;
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn + swIn;
	}
	_mm_empty();
}

/*
 * YUY2 -> YV12
 * C^[[X(FTvʒuMPEG2)ȉ摜p MMX
 *
 * (5,15,11,1)/32  4tap tB^[ivtB^{TuTvj
 * 8̔{̂ݑΉ
 */
void mmx_iq_yuy2_2_yv12(unsigned char *pBufferOut, const unsigned char *pBufferIn,
						unsigned int bpp, unsigned int Height, unsigned int Width,
						unsigned int swIn, unsigned int swOut)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	unsigned int i,j;
	const unsigned int coffs = (swOut * Height) / 4U; //F̃TCY
	const unsigned int hHeight = Height / 2U;
	unsigned int swIn2;
	const unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	const unsigned char *i0,*i1,*i2,*i3;
	__m64 m0,m1,m2,m3,mm,mr;

	//8̔{̂ݑΉ
	if(Width & 7U)
		return;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2U;
	swIn2 = swIn * 2U;

	//ỸRs[
	mm = _mm_setzero_si64();
	mm = _mm_cmpeq_pi8(mm, mm);
	mm = _mm_srli_pi16(mm, 8);
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=0; j<Width; j+=8U) {
			m0 = _mm_and_si64(*(__m64 *)i0,       mm);
			m1 = _mm_and_si64(*(__m64 *)(i0 + 8), mm);
			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m0, m1);
			tmp_pBufferOut += 8;
			i0 += 16;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	swOut /= 2U;
	mr = _mm_srli_pi16(mm, 7);
	mr = _mm_slli_pi16(mr, 4);
		for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1U){ //{g
			i1 = pBufferIn + swIn;
			i2 = i1 - swIn2;
			i3 = (i<2) ? i2 : i2 - swIn2;
			i0 = (i >= hHeight-2) ? i1 : i1 + swIn2;
		}else{ //gbv
			i1 = pBufferIn;
			i2 = i1 + swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}

		for(j=0; j<Width; j+=8U) {
			//1st
			// *5
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m3 = _mm_slli_pi16(m0, 2); //*4
			m0 = _mm_add_pi16(m0, m3); //+1
			// *15
			m1 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m3 = _mm_slli_pi16(m1, 4); //*16
			m3 = _mm_sub_pi16(m3, m1); //-1
			m0 = _mm_add_pi16(m0, m3);
			// *11
			m2 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m1 = _mm_slli_pi16(m2, 3); //*8
			m3 = _mm_slli_pi16(m2, 2); //*4
			m1 = _mm_sub_pi16(m1, m2); //-1
			m3 = _mm_add_pi16(m3, m1);
			// *1
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m1 = _mm_add_pi16(m1, m3);
			// +16
			m0 = _mm_add_pi16(m0, mr);
			m0 = _mm_add_pi16(m0, m1);
			mm = _mm_srli_pi16(m0, 5);
			// mm (v1,u1,v0,u0)
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
			//2nd
			// *5
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m3 = _mm_slli_pi16(m0, 2); //*4
			m0 = _mm_add_pi16(m0, m3); //+1
			// *15
			m1 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m3 = _mm_slli_pi16(m1, 4); //*16
			m3 = _mm_sub_pi16(m3, m1); //-1
			m0 = _mm_add_pi16(m0, m3);
			// *11
			m2 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m1 = _mm_slli_pi16(m2, 3); //*8
			m3 = _mm_slli_pi16(m2, 2); //*4
			m1 = _mm_sub_pi16(m1, m2); //-1
			m3 = _mm_add_pi16(m3, m1);
			// *1
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m1 = _mm_add_pi16(m1, m3);
			// +16
			m0 = _mm_add_pi16(m0, mr);
			m0 = _mm_add_pi16(m0, m1);
			m0 = _mm_srli_pi16(m0, 5);
			// m0 (v3,u3,v2,u2)

			//de-interleave
			m1 = _mm_unpackhi_pi16(mm, m0); //m1 (v3,v1,u3,u1)
			mm = _mm_unpacklo_pi16(mm, m0); //mm (v2,v0,u2,u0)
			m0 = _mm_unpackhi_pi16(mm, m1); //m0 (v3,v2,v1,v0)
			mm = _mm_unpacklo_pi16(mm, m1); //mm (u3,u2,u1,u0)

			m0 = _mm_packs_pu16(m0, m0); //v
			mm = _mm_packs_pu16(mm, mm); //u

			*(int *)tmp_pBufferOut = _mm_cvtsi64_si32(m0); //v
			*(int *)(tmp_pBufferOut + coffs) = _mm_cvtsi64_si32(mm); //u
			tmp_pBufferOut += 4;
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
	_mm_empty();
}

/*
 * YUY2 -> YV12
 * vObVuȉ摜p SSE2 Aligned
 *
 * (1,7,7,1)/16  4tap tB^[
 * 16̔{̂ݑΉ
 */
void sse2_yuy2_2_yv12(unsigned char *pBufferOut, const unsigned char *pBufferIn,
					  unsigned int bpp, unsigned int Height, unsigned int Width,
					  unsigned int swIn, unsigned int swOut)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	unsigned int i,j;
	const unsigned int coffs = (swOut * Height) / 4U; //F̃TCY
	const unsigned int hHeight = Height / 2U;
	const unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	const unsigned char *i0,*i1,*i2,*i3;
	__m128i m0,m1,m2,m3,mm;

	//16̔{̂ݑΉ
	if(Width & 15U)
		return;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2U;

	//ỸRs[
	mm = _mm_setzero_si128();
	mm = _mm_cmpeq_epi8(mm, mm);
	mm = _mm_srli_epi16(mm, 8);
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
			for(j = 0; j<Width; j+=16U) {
			m0 = _mm_load_si128((__m128i *)i0);
			m1 = _mm_load_si128((__m128i *)(i0 + 16));
			m0 = _mm_and_si128(m0, mm);
			m1 = _mm_and_si128(m1, mm);
			m0 = _mm_packus_epi16 (m0, m1);

			_mm_stream_si128((__m128i *)tmp_pBufferOut, m0);
			tmp_pBufferOut += 16;
			i0 += 32;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	swOut /= 2U;
	mm = _mm_srli_epi16(mm, 7);
	mm = _mm_slli_epi16(mm, 3);
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		i1 = pBufferIn;
		i2 = i1 + swIn;
		i0 = (i==0) ? i1 : i1 - swIn;
		i3 = (i >= hHeight-1U) ? i2 : i2 + swIn;

		for(j=0; j<Width; j+=16U) {
			//1st
			// +
			m0 = _mm_load_si128((__m128i *)i0);
			m1 = _mm_load_si128((__m128i *)i3);
			m0 = _mm_srli_epi16(m0, 8);
			m1 = _mm_srli_epi16(m1, 8);
			m0 = _mm_add_epi16(m0, m1);
			// *7
			m2 = _mm_load_si128((__m128i *)i1);
			m1 = _mm_load_si128((__m128i *)i2);
			m2 = _mm_srli_epi16(m2, 8);
			m1 = _mm_srli_epi16(m1, 8);
			m2 = _mm_add_epi16(m2, m1);
			m1 = _mm_slli_epi16(m2, 3);
			m1 = _mm_sub_epi16(m1, m2);
			// +8
			m0 = _mm_add_epi16(m0, mm);
			m0 = _mm_add_epi16(m0, m1);
			m3 = _mm_srli_epi16(m0, 4);
			// m3 (v3,u3,v2,u2,v1,u1,v0,u0)
			i0 += 16;
			i1 += 16;
			i2 += 16;
			i3 += 16;
			//2nd
			// +
			m0 = _mm_load_si128((__m128i *)i0);
			m1 = _mm_load_si128((__m128i *)i3);
			m0 = _mm_srli_epi16(m0, 8);
			m1 = _mm_srli_epi16(m1, 8);
			m0 = _mm_add_epi16(m0, m1);
			// *7
			m2 = _mm_load_si128((__m128i *)i1);
			m1 = _mm_load_si128((__m128i *)i2);
			m2 = _mm_srli_epi16(m2, 8);
			m1 = _mm_srli_epi16(m1, 8);
			m2 = _mm_add_epi16(m2, m1);
			m1 = _mm_slli_epi16(m2, 3);
			m1 = _mm_sub_epi16(m1, m2);
			// +8
			m0 = _mm_add_epi16(m0, mm);
			m0 = _mm_add_epi16(m0, m1);
			m0 = _mm_srli_epi16(m0, 4);
			// m0 (v7,u7,v6,u6,v5,u5,v4,u4)

			//de-interleave
			m1 = _mm_unpackhi_epi16(m3, m0); //m1 (v7,v3,u7,u3,v6,v2,u6,u2)
			m3 = _mm_unpacklo_epi16(m3, m0); //m3 (v5,v1,u5,u1,v4,v0,u4,u0)
			m2 = _mm_unpackhi_epi64(m3, m1); //m2 (v7,v3,u7,u3,v5,v1,u5,u1)
			m3 = _mm_unpacklo_epi64(m3, m1); //m3 (v6,v2,u6,u2,v4,v0,u4,u0)
			m0 = _mm_unpackhi_epi16(m3, m2); //m0 (v7,v6,v3,v2,u7,u6,u3,u2)
			m3 = _mm_unpacklo_epi16(m3, m2); //m3 (v5,v4,v1,v0,u5,u4,u1,u0)
			m1 = _mm_unpackhi_epi32(m3, m0); //m1 (v7,v6,v5,v4,v3,v2,v1,v0)
			m3 = _mm_unpacklo_epi32(m3, m0); //m3 (u7,u6,u5,u4,u3,u2,u1,u0)

			m1 = _mm_packus_epi16(m1, m1); //v
			m3 = _mm_packus_epi16(m3, m3); //u

			_mm_storel_epi64((__m128i *)tmp_pBufferOut, m1); //v
			_mm_storel_epi64((__m128i *)(tmp_pBufferOut + coffs), m3); //u
			tmp_pBufferOut += 8;
			i0 += 16;
			i1 += 16;
			i2 += 16;
			i3 += 16;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn + swIn;
	}
}



/*
 * YUY2 -> YV12
 * C^[[X(FTvʒuMPEG2)ȉ摜p SSE2
 *
 * (5,15,11,1)/32  4tap tB^[ivtB^{TuTvj
 * 16̔{̂ݑΉ
 */
void sse2_iq_yuy2_2_yv12(unsigned char *pBufferOut, const unsigned char *pBufferIn,
						 unsigned int bpp, unsigned int Height, unsigned int Width,
						 unsigned int swIn, unsigned int swOut)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	unsigned int i,j;
	const unsigned int coffs = (swOut * Height) / 4U; //F̃TCY
	const unsigned int hHeight = Height / 2U;
	unsigned int swIn2;
	const unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	const unsigned char *i0,*i1,*i2,*i3;
	__m128i m0,m1,m2,m3,mm,mr;

	//16̔{̂ݑΉ
	if(Width & 15U)
		return;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2U;
	swIn2 = swIn * 2U;

	//ỸRs[
	mm = _mm_setzero_si128();
	mm = _mm_cmpeq_epi8(mm, mm);
	mm = _mm_srli_epi16(mm, 8);
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j = 0; j<Width; j+=16U) {
			m0 = _mm_load_si128((__m128i *)i0);
			m1 = _mm_load_si128((__m128i *)(i0 + 16));
			m0 = _mm_and_si128(m0, mm);
			m1 = _mm_and_si128(m1, mm);
			m0 = _mm_packus_epi16 (m0, m1);

			_mm_stream_si128((__m128i *)tmp_pBufferOut, m0);
			tmp_pBufferOut += 16;
			i0 += 32;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	swOut /= 2U;
	mr = _mm_srli_epi16(mm, 7);
	mr = _mm_slli_epi16(mr, 4);
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1U){ //{g
			i1 = pBufferIn + swIn;
			i2 = i1 - swIn2;
			i3 = (i<2U) ? i2 : i2 - swIn2;
			i0 = (i >= hHeight-2U) ? i1 : i1 + swIn2;
		}else{ //gbv
			i1 = pBufferIn;
			i2 = i1 + swIn2;
			i0 = (i<2U) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2U) ? i2 : i2 + swIn2;
		}

		for(j=0; j<Width; j+=16U) {
			//1st
			// *5
			m0 = _mm_load_si128((__m128i *)i0);
			m0 = _mm_srli_epi16(m0, 8);
			m3 = _mm_slli_epi16(m0, 2); //*4
			m0 = _mm_add_epi16(m0, m3); //+1
			// *15
			m1 = _mm_load_si128((__m128i *)i1);
			m1 = _mm_srli_epi16(m1, 8);
			m3 = _mm_slli_epi16(m1, 4); //*16
			m3 = _mm_sub_epi16(m3, m1); //-1
			m0 = _mm_add_epi16(m0, m3);
			// *11
			m2 = _mm_load_si128((__m128i *)i2);
			m2 = _mm_srli_epi16(m2, 8);
			m1 = _mm_slli_epi16(m2, 3); //*8
			m3 = _mm_slli_epi16(m2, 2); //*4
			m1 = _mm_sub_epi16(m1, m2); //-1
			m3 = _mm_add_epi16(m3, m1);
			// *1
			m1 = _mm_load_si128((__m128i *)i3);
			m1 = _mm_srli_epi16(m1, 8);
			m1 = _mm_add_epi16(m1, m3);
			// +16
			m0 = _mm_add_epi16(m0, mr);
			m0 = _mm_add_epi16(m0, m1);
			mm = _mm_srli_epi16(m0, 5);
			// mm (v3,u3,v2,u2,v1,u1,v0,u0)
			i0 += 16;
			i1 += 16;
			i2 += 16;
			i3 += 16;
			//2nd
			// *5
			m0 = _mm_load_si128((__m128i *)i0);
			m0 = _mm_srli_epi16(m0, 8);
			m3 = _mm_slli_epi16(m0, 2); //*4
			m0 = _mm_add_epi16(m0, m3); //+1
			// *15
			m1 = _mm_load_si128((__m128i *)i1);
			m1 = _mm_srli_epi16(m1, 8);
			m3 = _mm_slli_epi16(m1, 4); //*16
			m3 = _mm_sub_epi16(m3, m1); //-1
			m0 = _mm_add_epi16(m0, m3);
			// *11
			m2 = _mm_load_si128((__m128i *)i2);
			m2 = _mm_srli_epi16(m2, 8);
			m1 = _mm_slli_epi16(m2, 3); //*8
			m3 = _mm_slli_epi16(m2, 2); //*4
			m1 = _mm_sub_epi16(m1, m2); //-1
			m3 = _mm_add_epi16(m3, m1);
			// *1
			m1 = _mm_load_si128((__m128i *)i3);
			m1 = _mm_srli_epi16(m1, 8);
			m1 = _mm_add_epi16(m1, m3);
			// +16
			m0 = _mm_add_epi16(m0, mr);
			m0 = _mm_add_epi16(m0, m1);
			m0 = _mm_srli_epi16(m0, 5);
			// m0 (v7,u7,v6,u6,v5,u5,v4,u4)

			//de-interleave
			m1 = _mm_unpackhi_epi16(mm, m0); //m1 (v7,v3,u7,u3,v6,v2,u6,u2)
			mm = _mm_unpacklo_epi16(mm, m0); //mm (v5,v1,u5,u1,v4,v0,u4,u0)
			m2 = _mm_unpackhi_epi64(mm, m1); //m2 (v7,v3,u7,u3,v5,v1,u5,u1)
			mm = _mm_unpacklo_epi64(mm, m1); //mm (v6,v2,u6,u2,v4,v0,u4,u0)
			m0 = _mm_unpackhi_epi16(mm, m2); //m0 (v7,v6,v3,v2,u7,u6,u3,u2)
			mm = _mm_unpacklo_epi16(mm, m2); //mm (v5,v4,v1,v0,u5,u4,u1,u0)
			m1 = _mm_unpackhi_epi32(mm, m0); //m1 (v7,v6,v5,v4,v3,v2,v1,v0)
			mm = _mm_unpacklo_epi32(mm, m0); //mm (u7,u6,u5,u4,u3,u2,u1,u0)

			m1 = _mm_packus_epi16(m1, m1); //v
			mm = _mm_packus_epi16(mm, mm); //u

			_mm_storel_epi64((__m128i *)tmp_pBufferOut, m1); //v
			_mm_storel_epi64((__m128i *)(tmp_pBufferOut + coffs), mm); //u
			tmp_pBufferOut += 8;
			i0 += 16;
			i1 += 16;
			i2 += 16;
			i3 += 16;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
}
